Subject: bug#59900: 30.0.50; map pattern in pcase causes a byte-compile error

From: Eli Zaretskii <[email-masked]>
Date: Fri, 09 Dec 2022 09:12:17 +0200

> From: Michael Heerdegen <[email-masked]>
> Cc: Eli Zaretskii <[email-masked]>,  [email-masked]
> Date: Fri, 09 Dec 2022 03:11:14 +0100
> 
> Akira Komamura <[email-masked]> writes:
> 
> > I encountered similar errors in other libraries that contain a `map' pattern
> > inside a `pcase' form. It didn't happen until recently, when I updated Emacs
> > and
> > began to get those errors.
> >
> >  So I wonder where's the place in the core Emacs sources
> >  which causes the problem, and I couldn't find it.  I'm probably
> >  missing something.
> 
> Maybe it started with
> 
> | 85555ad3b79 ; Require map only during compilation
> | Philip Kaludercic <[email-masked]> 2022-10-23
> 
> Anyway, AFAIU currently compiling pcase forms with `map' patterns
> requires map.el to be currently loaded, and since you can't (and could
> not) rely on that, it's better to add
> (eval-when-compile (require 'map)).

Thanks, but all this still doesn't answer my questions,
unfortunately.  You-all are describing something that I cannot wrap my
head around, because that basic question was not answered yet.

Would someone please take me through the problem step by step?  ELI5,
OK?